<?php

/**
 * @file
 * Contains \Drupal\video_embed_twitch\Plugin\video_embed_field\Provider\Twitch.
 */

namespace Drupal\video_embed_twitch\Plugin\video_embed_field\Provider;

use Drupal\video_embed_field\ProviderPluginBase;

/**
 * @VideoEmbedProvider(
 *   id = "twitch",
 *   title = @Translation("Twitch")
 * )
 */
class Twitch extends ProviderPluginBase {

  /**
   * {@inheritdoc}
   */
  public function renderEmbedCode($width, $height, $autoplay) {
    //    <iframe frameborder="<frameborder width>"
    //        scrolling="<scrolling>"
    //        src="<src url>" http://player.twitch.tv/?channel=dallas&muted=true
    //        height="<height>" 720
    //        width="<width>"> 1280
    //    </iframe>
    return [
      '#type' => 'video_embed_iframe',
      '#provider' => 'twitch',
      '#url' => sprintf('https://player.twitch.tv/?channel=%s', $this->getVideoId()),
      '#attributes' => [
        'width' => $width,
        'height' => $height,
        'frameborder' => '0',
        'scrolling' => 'no',
        'allowfullscreen' => 'allowfullscreen',
      ],
    ];
  }

  //<iframe src="https://player.twitch.tv/?channel=wishyouluckk" frameborder="0" allowfullscreen="true" scrolling="no" height="378" width="620"></iframe><a href="https://www.twitch.tv/wishyouluckk?tt_content=text_link&tt_medium=live_embed" style="padding:2px 0px 4px; display:block; width:345px; font-weight:normal; font-size:10px; text-decoration:underline;">Watch live video from WishYouLuckk on www.twitch.tv</a>
  /**
   * {@inheritdoc}
   */
  public function getRemoteThumbnailUrl() {
    return false;
  }

  /**
   * {@inheritdoc}
   */
  public static function getIdFromInput($input) {
    preg_match('/^https?:\/\/(player)?\.twitch\.tv\/\?channel\=(?<channel>[a-zA-Z0-9]*)?$/', $input, $matches);
    kint($matches);
    return isset($matches['channel']) ? $matches['channel'] : FALSE;
  }

}
