<?php

/**
 * @file
 * Contains Drupal\Tests\video_embed_twitch\Unit\ProviderUrlParseTest.
 */

namespace Drupal\Tests\video_embed_twitch\Unit;

use Drupal\Tests\UnitTestCase;
use Drupal\video_embed_twitch\Plugin\video_embed_field\Provider\Twitch;

/**
 * Test that URL parsing for the provider is functioning.
 *
 * @group video_embed_instagram
 */
class ProviderUrlParseTest extends UnitTestCase {

  /**
   * @dataProvider urlsWithExpectedIds
   *
   * Test URL parsing works as expected.
   */
  public function testUrlParsing($url, $expected) {
    $this->assertEquals($expected, Twitch::getIdFromInput($url));
  }

  /**
   * A data provider for URL parsing test cases.
   *
   * @return array
   *   An array of test cases.
   */
  public function urlsWithExpectedIds() {
    return [
      [
        'https://player.twitch.tv/?channel=dallas',
        'dallas',
      ],
      [
        'http://player.twitch.tv/?channel=dallas/',
        'dallas',
      ],
    ];
  }
}
